LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_arith.ALL;
USE ieee.std_logic_unsigned.all;

entity mux8x1 is
    port (data : in std_logic_vector(7 downto 0);
          sel  : in std_logic_vector(2 downto 0);
          en   : in std_logic;
          f    : out std_logic
         );
end mux8x1;

architecture rtl of mux8x1 is
begin
    process (sel, data, en)
    begin
        if en = '1' then
            f <= data(conv_integer(UNSIGNED(sel)));
        else
            f <= '0';
        end if;

--		  case sel is
--            when "000" => f <= data(0);
--            when "001" => f <= data(1);
--            when "010" => f <= data(2);
--            when "011" => f <= data(3);
--            when "100" => f <= data(4);
--            when "101" => f <= data(5);
--            when "110" => f <= data(6);
--            when "111" => f <= data(7);
--				when others => f <= 'X';
--        end case;				
    end process;
end rtl;
